import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useRef /* , useState */ } from 'react';
import { initLoadMicroApp } from './LoaderQueue';
export function MfComponentLoader({ app, props, className, placeholder = 'mf original', }) {
    const containerRef = useRef(null);
    useEffect(() => {
        if (!app) {
            console.error('No micro app was provied! microapp components wont render!`');
            return;
        }
        let loadedapp;
        initLoadMicroApp(app, props, containerRef, (lApp) => {
            loadedapp = lApp;
        });
        return () => {
            if (!loadedapp) {
                console.error('loadedapp is undefined!');
                return;
            }
            loadedapp.unmount();
        };
    }, []);
    // if (pending) {
    // return <div>pending... {placeholder}</div>
    // }
    return (_jsx("div", { ref: containerRef, className: className, children: placeholder }));
}
//# sourceMappingURL=ComponentLoader.js.map