import { useEffect, useRef /* , useState */ } from 'react'
import type { MicroApp, ObjectType } from '../qiankun'

import { IMfComponentLoader, initLoadMicroApp } from './LoaderQueue'

export function MfComponentLoader<T extends ObjectType>({
    app,
    props,
    className,
    placeholder = 'mf original',
}: IMfComponentLoader<T>) {
    const containerRef = useRef<HTMLDivElement>(null)

    useEffect(() => {
        if (!app) {
            console.error('No micro app was provied! microapp components wont render!`')
            return
        }

        let loadedapp: MicroApp | undefined

        initLoadMicroApp(app, props, containerRef, (lApp) => {
            loadedapp = lApp
        })

        return () => {
            if (!loadedapp) {
                console.error('loadedapp is undefined!')
                return
            }
            loadedapp.unmount()
        }
    }, [])

    // if (pending) {
    // return <div>pending... {placeholder}</div>
    // }
    return (
        <div ref={containerRef} className={className}>
            {placeholder}
        </div>
    )
}
